package com.kingdee.eas.custom.shengshen.utils;

import com.itextpdf.text.pdf.AcroFields;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfStamper;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.Map;

public class PDFFillInformationUtil {
    /**
     * pdf
     * @param fileName ԭʼļ
     * @param field map<String,String> key Ϊֶvalue Ϊֵ
     * @return ļ  ļΪbyte[]
     */
    public byte[] fillInformation(String fileName, Map<String,String> field) throws IOException {
        //http://169.254.157.139:6888/easWebClient/download/DSF_Mod_373.pdf
        String url = "http://169.254.157.139:6888/easWebClient/download/"+fileName;
        byte[] bytesByNetURL = HttpClient3.getBytesByNetURL(url);
        try {
            System.setProperty("javax.xml.parsers.DocumentBuilderFactory","com.sun.org.apache.xerces.internal.jaxp.DocumentBuilderFactoryImpl");
            // ȡPDFģ
            PdfReader pdfReader = new PdfReader(bytesByNetURL);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            // ͸PDFļ
            PdfStamper pdfStamper = new PdfStamper(pdfReader, baos);
            AcroFields form = pdfStamper.getAcroFields();
            // ֶ
            Iterator<Map.Entry<String, String>> iterator = field.entrySet().iterator();
            while (iterator.hasNext()) {
                Map.Entry<String, String> entry = iterator.next();
                String key = entry.getKey();
                String value = entry.getValue();
                //ֵֶ
                form.setField(key, value);
            }
            //ɺpdf ڱ༭
            pdfStamper.setFormFlattening(false);
            // ر޸ͷԴ
            pdfStamper.close();
            pdfReader.close();
            return  baos.toByteArray();
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("pdf ʧܣ");
        }
    }
}
